function RationalSSM
%  Implementation of the 'exotic' scheme
%   y(k+1) = (2-z^2)/(2(1-z)) * y(k)

% given data
alpha  = [ ];
beta   = [ ];
h      = [ ];

T = [ ];
y0 = [ ];

tExact = T(1):0.05:T(2);

% loop over all parameter configurations
for p = 1:length(alpha)
	
	% set up matrix A
	A = [  ];
   
	% evaluate stabilty function at hA
	R =  ;
	
	% define time steps
	t = T(1):h(p):T(2);
	
	% allocate memory for results
	y = nan(2,length(t));
	
	% store initial value
	y(:,1) =  ;
	
	% time stepping
	for k=1:length(t)
		
		y(:,k+1) =  ;
	end
	
	% plot results
	figure;
	
	% limit axis in case of blow-up in analytical solution
	if ( real(eig(A)) > 0)
		
		axis([-1,4,-1,4]);
	else
		
		axis equal;
	end
  
	hold on;
	grid on;
	
	% compute exact solution
	yExact = sol(tExact,y0,alpha(p),beta(p));
	
	% plot computed solution
	plot(y(1,:), y(2,:), 'r', 'LineWidth', 2.5);
	
	% plot exact solution
	plot(yExact(1,:), yExact(2,:), 'g', 'Linewidth', 1.2);
	
	% plot initial value
	plot(y0(1), y0(2), 'gh', 'LineWidth', 2.5, 'MarkerSize', 12);
	
	% plot final value of computed solution
	plot(y(1,end), y(2,end), 'mx', 'LineWidth', 2.5, 'MarkerSize',16);
	
	% plot final value of exact solution
	plot(yExact(1,end), yExact(2,end), 'b.', 'LineWidth', 2.5, 'MarkerSize', 18)
	
	legend('Numerical',...
		 'Exact',...
		 'y0',...
		 ['y_h(', num2str(T(2)), ')'],...
		 ['y(',   num2str(T(2)), ')'],...
		 'Location','SouthEast');
	 
	title(['Solution for',...
		' \alpha=', num2str(alpha(p)),...
		', \beta=', num2str(beta(p)),...
		' with step size h=', num2str(h(p))]);
	
	hold off
	
	print(strcat('Rationalssm',num2str(p)),'-dpdf');
	
end

function yExact = sol(t,y0,alpha,beta)
% implementation of exact solution

  yExact = nan(2,length(t));
  yExact(1,:) = y0(1)*exp(t*alpha).*( cos(t*beta) + sin(t*beta) );
  yExact(2,:) = y0(2)*exp(t*alpha).*( cos(t*beta) - sin(t*beta) );